// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from automotive_platform_msgs:msg/AdaptiveCruiseControlSettings.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__ADAPTIVE_CRUISE_CONTROL_SETTINGS__TRAITS_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__ADAPTIVE_CRUISE_CONTROL_SETTINGS__TRAITS_HPP_

#include "automotive_platform_msgs/msg/detail/adaptive_cruise_control_settings__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const automotive_platform_msgs::msg::AdaptiveCruiseControlSettings & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: set_speed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "set_speed: ";
    value_to_yaml(msg.set_speed, out);
    out << "\n";
  }

  // member: following_spot
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "following_spot: ";
    value_to_yaml(msg.following_spot, out);
    out << "\n";
  }

  // member: min_percent
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_percent: ";
    value_to_yaml(msg.min_percent, out);
    out << "\n";
  }

  // member: step_percent
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "step_percent: ";
    value_to_yaml(msg.step_percent, out);
    out << "\n";
  }

  // member: cipv_percent
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cipv_percent: ";
    value_to_yaml(msg.cipv_percent, out);
    out << "\n";
  }

  // member: max_distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_distance: ";
    value_to_yaml(msg.max_distance, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const automotive_platform_msgs::msg::AdaptiveCruiseControlSettings & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<automotive_platform_msgs::msg::AdaptiveCruiseControlSettings>()
{
  return "automotive_platform_msgs::msg::AdaptiveCruiseControlSettings";
}

template<>
inline const char * name<automotive_platform_msgs::msg::AdaptiveCruiseControlSettings>()
{
  return "automotive_platform_msgs/msg/AdaptiveCruiseControlSettings";
}

template<>
struct has_fixed_size<automotive_platform_msgs::msg::AdaptiveCruiseControlSettings>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<automotive_platform_msgs::msg::AdaptiveCruiseControlSettings>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<automotive_platform_msgs::msg::AdaptiveCruiseControlSettings>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__ADAPTIVE_CRUISE_CONTROL_SETTINGS__TRAITS_HPP_
