// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_platform_msgs:msg/AdaptiveCruiseControlSettings.idl
// generated code does not contain a copyright notice
#include "automotive_platform_msgs/msg/detail/adaptive_cruise_control_settings__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__init(automotive_platform_msgs__msg__AdaptiveCruiseControlSettings * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__fini(msg);
    return false;
  }
  // set_speed
  // following_spot
  // min_percent
  // step_percent
  // cipv_percent
  // max_distance
  return true;
}

void
automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__fini(automotive_platform_msgs__msg__AdaptiveCruiseControlSettings * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // set_speed
  // following_spot
  // min_percent
  // step_percent
  // cipv_percent
  // max_distance
}

bool
automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__are_equal(const automotive_platform_msgs__msg__AdaptiveCruiseControlSettings * lhs, const automotive_platform_msgs__msg__AdaptiveCruiseControlSettings * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // set_speed
  if (lhs->set_speed != rhs->set_speed) {
    return false;
  }
  // following_spot
  if (lhs->following_spot != rhs->following_spot) {
    return false;
  }
  // min_percent
  if (lhs->min_percent != rhs->min_percent) {
    return false;
  }
  // step_percent
  if (lhs->step_percent != rhs->step_percent) {
    return false;
  }
  // cipv_percent
  if (lhs->cipv_percent != rhs->cipv_percent) {
    return false;
  }
  // max_distance
  if (lhs->max_distance != rhs->max_distance) {
    return false;
  }
  return true;
}

bool
automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__copy(
  const automotive_platform_msgs__msg__AdaptiveCruiseControlSettings * input,
  automotive_platform_msgs__msg__AdaptiveCruiseControlSettings * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // set_speed
  output->set_speed = input->set_speed;
  // following_spot
  output->following_spot = input->following_spot;
  // min_percent
  output->min_percent = input->min_percent;
  // step_percent
  output->step_percent = input->step_percent;
  // cipv_percent
  output->cipv_percent = input->cipv_percent;
  // max_distance
  output->max_distance = input->max_distance;
  return true;
}

automotive_platform_msgs__msg__AdaptiveCruiseControlSettings *
automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__create()
{
  automotive_platform_msgs__msg__AdaptiveCruiseControlSettings * msg = (automotive_platform_msgs__msg__AdaptiveCruiseControlSettings *)malloc(sizeof(automotive_platform_msgs__msg__AdaptiveCruiseControlSettings));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_platform_msgs__msg__AdaptiveCruiseControlSettings));
  bool success = automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__destroy(automotive_platform_msgs__msg__AdaptiveCruiseControlSettings * msg)
{
  if (msg) {
    automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__fini(msg);
  }
  free(msg);
}


bool
automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence__init(automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  automotive_platform_msgs__msg__AdaptiveCruiseControlSettings * data = NULL;
  if (size) {
    data = (automotive_platform_msgs__msg__AdaptiveCruiseControlSettings *)calloc(size, sizeof(automotive_platform_msgs__msg__AdaptiveCruiseControlSettings));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence__fini(automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence *
automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence__create(size_t size)
{
  automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence * array = (automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence *)malloc(sizeof(automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence__destroy(automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence * array)
{
  if (array) {
    automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence__fini(array);
  }
  free(array);
}

bool
automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence__are_equal(const automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence * lhs, const automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence__copy(
  const automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence * input,
  automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(automotive_platform_msgs__msg__AdaptiveCruiseControlSettings);
    automotive_platform_msgs__msg__AdaptiveCruiseControlSettings * data =
      (automotive_platform_msgs__msg__AdaptiveCruiseControlSettings *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
