// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from automotive_platform_msgs:msg/DriverCommands.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__DRIVER_COMMANDS__BUILDER_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__DRIVER_COMMANDS__BUILDER_HPP_

#include "automotive_platform_msgs/msg/detail/driver_commands__struct.hpp"
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <utility>


namespace automotive_platform_msgs
{

namespace msg
{

namespace builder
{

class Init_DriverCommands_left_turn
{
public:
  explicit Init_DriverCommands_left_turn(::automotive_platform_msgs::msg::DriverCommands & msg)
  : msg_(msg)
  {}
  ::automotive_platform_msgs::msg::DriverCommands left_turn(::automotive_platform_msgs::msg::DriverCommands::_left_turn_type arg)
  {
    msg_.left_turn = std::move(arg);
    return std::move(msg_);
  }

private:
  ::automotive_platform_msgs::msg::DriverCommands msg_;
};

class Init_DriverCommands_right_turn
{
public:
  explicit Init_DriverCommands_right_turn(::automotive_platform_msgs::msg::DriverCommands & msg)
  : msg_(msg)
  {}
  Init_DriverCommands_left_turn right_turn(::automotive_platform_msgs::msg::DriverCommands::_right_turn_type arg)
  {
    msg_.right_turn = std::move(arg);
    return Init_DriverCommands_left_turn(msg_);
  }

private:
  ::automotive_platform_msgs::msg::DriverCommands msg_;
};

class Init_DriverCommands_closer
{
public:
  explicit Init_DriverCommands_closer(::automotive_platform_msgs::msg::DriverCommands & msg)
  : msg_(msg)
  {}
  Init_DriverCommands_right_turn closer(::automotive_platform_msgs::msg::DriverCommands::_closer_type arg)
  {
    msg_.closer = std::move(arg);
    return Init_DriverCommands_right_turn(msg_);
  }

private:
  ::automotive_platform_msgs::msg::DriverCommands msg_;
};

class Init_DriverCommands_further
{
public:
  explicit Init_DriverCommands_further(::automotive_platform_msgs::msg::DriverCommands & msg)
  : msg_(msg)
  {}
  Init_DriverCommands_closer further(::automotive_platform_msgs::msg::DriverCommands::_further_type arg)
  {
    msg_.further = std::move(arg);
    return Init_DriverCommands_closer(msg_);
  }

private:
  ::automotive_platform_msgs::msg::DriverCommands msg_;
};

class Init_DriverCommands_slow_down
{
public:
  explicit Init_DriverCommands_slow_down(::automotive_platform_msgs::msg::DriverCommands & msg)
  : msg_(msg)
  {}
  Init_DriverCommands_further slow_down(::automotive_platform_msgs::msg::DriverCommands::_slow_down_type arg)
  {
    msg_.slow_down = std::move(arg);
    return Init_DriverCommands_further(msg_);
  }

private:
  ::automotive_platform_msgs::msg::DriverCommands msg_;
};

class Init_DriverCommands_speed_up
{
public:
  explicit Init_DriverCommands_speed_up(::automotive_platform_msgs::msg::DriverCommands & msg)
  : msg_(msg)
  {}
  Init_DriverCommands_slow_down speed_up(::automotive_platform_msgs::msg::DriverCommands::_speed_up_type arg)
  {
    msg_.speed_up = std::move(arg);
    return Init_DriverCommands_slow_down(msg_);
  }

private:
  ::automotive_platform_msgs::msg::DriverCommands msg_;
};

class Init_DriverCommands_disengage
{
public:
  explicit Init_DriverCommands_disengage(::automotive_platform_msgs::msg::DriverCommands & msg)
  : msg_(msg)
  {}
  Init_DriverCommands_speed_up disengage(::automotive_platform_msgs::msg::DriverCommands::_disengage_type arg)
  {
    msg_.disengage = std::move(arg);
    return Init_DriverCommands_speed_up(msg_);
  }

private:
  ::automotive_platform_msgs::msg::DriverCommands msg_;
};

class Init_DriverCommands_engage
{
public:
  explicit Init_DriverCommands_engage(::automotive_platform_msgs::msg::DriverCommands & msg)
  : msg_(msg)
  {}
  Init_DriverCommands_disengage engage(::automotive_platform_msgs::msg::DriverCommands::_engage_type arg)
  {
    msg_.engage = std::move(arg);
    return Init_DriverCommands_disengage(msg_);
  }

private:
  ::automotive_platform_msgs::msg::DriverCommands msg_;
};

class Init_DriverCommands_msg_counter
{
public:
  Init_DriverCommands_msg_counter()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_DriverCommands_engage msg_counter(::automotive_platform_msgs::msg::DriverCommands::_msg_counter_type arg)
  {
    msg_.msg_counter = std::move(arg);
    return Init_DriverCommands_engage(msg_);
  }

private:
  ::automotive_platform_msgs::msg::DriverCommands msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::automotive_platform_msgs::msg::DriverCommands>()
{
  return automotive_platform_msgs::msg::builder::Init_DriverCommands_msg_counter();
}

}  // namespace automotive_platform_msgs

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__DRIVER_COMMANDS__BUILDER_HPP_
