// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from automotive_platform_msgs:msg/Speed.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__SPEED__BUILDER_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__SPEED__BUILDER_HPP_

#include "automotive_platform_msgs/msg/detail/speed__struct.hpp"
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <utility>


namespace automotive_platform_msgs
{

namespace msg
{

namespace builder
{

class Init_Speed_deceleration_limit
{
public:
  explicit Init_Speed_deceleration_limit(::automotive_platform_msgs::msg::Speed & msg)
  : msg_(msg)
  {}
  ::automotive_platform_msgs::msg::Speed deceleration_limit(::automotive_platform_msgs::msg::Speed::_deceleration_limit_type arg)
  {
    msg_.deceleration_limit = std::move(arg);
    return std::move(msg_);
  }

private:
  ::automotive_platform_msgs::msg::Speed msg_;
};

class Init_Speed_acceleration_limit
{
public:
  explicit Init_Speed_acceleration_limit(::automotive_platform_msgs::msg::Speed & msg)
  : msg_(msg)
  {}
  Init_Speed_deceleration_limit acceleration_limit(::automotive_platform_msgs::msg::Speed::_acceleration_limit_type arg)
  {
    msg_.acceleration_limit = std::move(arg);
    return Init_Speed_deceleration_limit(msg_);
  }

private:
  ::automotive_platform_msgs::msg::Speed msg_;
};

class Init_Speed_speed
{
public:
  explicit Init_Speed_speed(::automotive_platform_msgs::msg::Speed & msg)
  : msg_(msg)
  {}
  Init_Speed_acceleration_limit speed(::automotive_platform_msgs::msg::Speed::_speed_type arg)
  {
    msg_.speed = std::move(arg);
    return Init_Speed_acceleration_limit(msg_);
  }

private:
  ::automotive_platform_msgs::msg::Speed msg_;
};

class Init_Speed_module_name
{
public:
  explicit Init_Speed_module_name(::automotive_platform_msgs::msg::Speed & msg)
  : msg_(msg)
  {}
  Init_Speed_speed module_name(::automotive_platform_msgs::msg::Speed::_module_name_type arg)
  {
    msg_.module_name = std::move(arg);
    return Init_Speed_speed(msg_);
  }

private:
  ::automotive_platform_msgs::msg::Speed msg_;
};

class Init_Speed_header
{
public:
  Init_Speed_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Speed_module_name header(::automotive_platform_msgs::msg::Speed::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_Speed_module_name(msg_);
  }

private:
  ::automotive_platform_msgs::msg::Speed msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::automotive_platform_msgs::msg::Speed>()
{
  return automotive_platform_msgs::msg::builder::Init_Speed_header();
}

}  // namespace automotive_platform_msgs

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__SPEED__BUILDER_HPP_
