// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_platform_msgs:msg/SteerMode.idl
// generated code does not contain a copyright notice
#include "automotive_platform_msgs/msg/detail/steer_mode__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
automotive_platform_msgs__msg__SteerMode__init(automotive_platform_msgs__msg__SteerMode * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    automotive_platform_msgs__msg__SteerMode__fini(msg);
    return false;
  }
  // mode
  // curvature
  // max_curvature_rate
  return true;
}

void
automotive_platform_msgs__msg__SteerMode__fini(automotive_platform_msgs__msg__SteerMode * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // mode
  // curvature
  // max_curvature_rate
}

bool
automotive_platform_msgs__msg__SteerMode__are_equal(const automotive_platform_msgs__msg__SteerMode * lhs, const automotive_platform_msgs__msg__SteerMode * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // mode
  if (lhs->mode != rhs->mode) {
    return false;
  }
  // curvature
  if (lhs->curvature != rhs->curvature) {
    return false;
  }
  // max_curvature_rate
  if (lhs->max_curvature_rate != rhs->max_curvature_rate) {
    return false;
  }
  return true;
}

bool
automotive_platform_msgs__msg__SteerMode__copy(
  const automotive_platform_msgs__msg__SteerMode * input,
  automotive_platform_msgs__msg__SteerMode * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // mode
  output->mode = input->mode;
  // curvature
  output->curvature = input->curvature;
  // max_curvature_rate
  output->max_curvature_rate = input->max_curvature_rate;
  return true;
}

automotive_platform_msgs__msg__SteerMode *
automotive_platform_msgs__msg__SteerMode__create()
{
  automotive_platform_msgs__msg__SteerMode * msg = (automotive_platform_msgs__msg__SteerMode *)malloc(sizeof(automotive_platform_msgs__msg__SteerMode));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_platform_msgs__msg__SteerMode));
  bool success = automotive_platform_msgs__msg__SteerMode__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
automotive_platform_msgs__msg__SteerMode__destroy(automotive_platform_msgs__msg__SteerMode * msg)
{
  if (msg) {
    automotive_platform_msgs__msg__SteerMode__fini(msg);
  }
  free(msg);
}


bool
automotive_platform_msgs__msg__SteerMode__Sequence__init(automotive_platform_msgs__msg__SteerMode__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  automotive_platform_msgs__msg__SteerMode * data = NULL;
  if (size) {
    data = (automotive_platform_msgs__msg__SteerMode *)calloc(size, sizeof(automotive_platform_msgs__msg__SteerMode));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_platform_msgs__msg__SteerMode__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_platform_msgs__msg__SteerMode__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_platform_msgs__msg__SteerMode__Sequence__fini(automotive_platform_msgs__msg__SteerMode__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_platform_msgs__msg__SteerMode__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_platform_msgs__msg__SteerMode__Sequence *
automotive_platform_msgs__msg__SteerMode__Sequence__create(size_t size)
{
  automotive_platform_msgs__msg__SteerMode__Sequence * array = (automotive_platform_msgs__msg__SteerMode__Sequence *)malloc(sizeof(automotive_platform_msgs__msg__SteerMode__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = automotive_platform_msgs__msg__SteerMode__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
automotive_platform_msgs__msg__SteerMode__Sequence__destroy(automotive_platform_msgs__msg__SteerMode__Sequence * array)
{
  if (array) {
    automotive_platform_msgs__msg__SteerMode__Sequence__fini(array);
  }
  free(array);
}

bool
automotive_platform_msgs__msg__SteerMode__Sequence__are_equal(const automotive_platform_msgs__msg__SteerMode__Sequence * lhs, const automotive_platform_msgs__msg__SteerMode__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!automotive_platform_msgs__msg__SteerMode__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
automotive_platform_msgs__msg__SteerMode__Sequence__copy(
  const automotive_platform_msgs__msg__SteerMode__Sequence * input,
  automotive_platform_msgs__msg__SteerMode__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(automotive_platform_msgs__msg__SteerMode);
    automotive_platform_msgs__msg__SteerMode * data =
      (automotive_platform_msgs__msg__SteerMode *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!automotive_platform_msgs__msg__SteerMode__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          automotive_platform_msgs__msg__SteerMode__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!automotive_platform_msgs__msg__SteerMode__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
